#!/usr/bin/env perl
# $Id: kuttuki-vote.cgi,v 1.2 2003/10/07 17:37:13 yto Exp $
use strict;
use Jcode;
use CGI qw( :standard );

my $vote_file_dir = "kvote";

my $id = param('id');
my $ans = param('ans');
my $encode = param('encode') || "euc";

my %cn = ("euc" => "EUC-JP", "sjis" => "Shift_JIS");

$id =~ s/[^a-zA-Z0-9\-_]//g;
my $fn = "$vote_file_dir/$id";
open(F, "$fn") or die "can't open $fn : $!\n";
my $all = join('', <F>);
close(F);

Jcode::convert(\$all, $encode);

my @opt;
foreach (split(/\r?\n/, $all)) {
    next if (/^\s*$/);
    push @opt, [split(/\t/, $_)];
}

if (defined $ans) {

    $opt[$ans]->[1]++;
    open(F, "> $fn") or die "can't open $fn : $!\n";
    flock(F, 2);
    print F map {"$_->[0]\t$_->[1]\n"} @opt;
    close(F);

    (my $ostr = << "HTML") =~ s/^\s+//gm;
    <html><head>
    <META HTTP-EQUIV="Content-Type"
    CONTENT="text/html;charset=@{[$cn{'$encode'} ? $cn{'$encode'} : $encode]}">
    <title>kuttuki vote</title>
    </head><body>
    <h1>result</h1><ul>@{[map {"<li>".($_->[1]+0)." : $_->[0]\n"} @opt]}</ul>
    <div align="right">Powered by 
    <a href="http://nais.to/~yto/tools/kuttuki-vote/">
    <b>Kuttuki Vote</b></a></div>
    </body></html>
HTML
    print "Content-type: text/html;\n\n$ostr";

} else {

    my $url_base = "http://".$ENV{'SERVER_NAME'}.$ENV{'REQUEST_URI'};
    my @li;
    for (my $i = 0; $i < @opt; $i++) {
	my ($c, $n) = ($opt[$i]->[0], $opt[$i]->[1] + 0);
	$c =~ s/\'/&\#x27;/g;
	push @li, qq(<a target="_blank" href="$url_base&ans=$i">$c($n)</a> );
    }
    print "Content-type: text/plain;\n\ndocument.write('@li');\n";

}
